#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
typedef tree<pair<ll, ll>, null_type, less<pair<ll, ll> >, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
ordered_set st;
ll n, i, h[100002], t, k, l1, r1, l2, r2, mx1, mx2, d[800002], mxr[800002], mxl[800002], sum[800002], s[800002], cl[
            100002], cr[100002];
vector<ll> v;

void build(ll v, ll l, ll r) {
    if (l == r) {
        d[v] = -1;
        mxl[v] = l;
        mxr[v] = l;
        sum[v] = h[l];
        return;
    }
    ll m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
    sum[v] = sum[2 * v] + sum[2 * v + 1];
    if (h[mxl[2 * v]] >= h[mxl[2 * v + 1]]) {
        mxl[v] = mxl[2 * v];
    } else {
        mxl[v] = mxl[2 * v + 1];
    }
    if (h[mxr[2 * v]] <= h[mxr[2 * v + 1]]) {
        mxr[v] = mxr[2 * v + 1];
    } else {
        mxr[v] = mxr[2 * v];
    }
}

void upd(ll v, ll l, ll r, ll a, ll b, ll x) {
    s[v] = max(s[v], d[v] * (r - l + 1) - sum[v]);
    if (l == a && r == b) {
        d[v] = max(d[v], x);
        s[v] = max(s[v], d[v] * (r - l + 1) - sum[v]);
        return;
    }
    ll m = (l + r) / 2;
    d[2 * v] = max(d[2 * v], d[v]);
    d[2 * v + 1] = max(d[2 * v + 1], d[v]);
    if (m >= b) {
        upd(2 * v, l, m, a, b, x);
    } else if (m < a) {
        upd(2 * v + 1, m + 1, r, a, b, x);
    } else {
        upd(2 * v, l, m, a, m, x);
        upd(2 * v + 1, m + 1, r, m + 1, b, x);
    }
    s[v] = s[2 * v] + s[2 * v + 1];
}

ll fmxl(ll v, ll l, ll r, ll a, ll b) {
    if (l == a && r == b) {
        return mxl[v];
    }
    ll m = (l + r) / 2;
    if (m >= b) {
        return fmxl(2 * v, l, m, a, b);
    }
    if (m < a) {
        return fmxl(2 * v + 1, m + 1, r, a, b);
    }
    ll t1 = fmxl(2 * v, l, m, a, m);
    ll t2 = fmxl(2 * v + 1, m + 1, r, m + 1, b);
    if (h[t1] >= h[t2]) {
        return t1;
    }
    return t2;
}

ll fmxr(ll v, ll l, ll r, ll a, ll b) {
    if (l == a && r == b) {
        return mxr[v];
    }
    ll m = (l + r) / 2;
    if (m >= b) {
        return fmxr(2 * v, l, m, a, b);
    }
    if (m < a) {
        return fmxr(2 * v + 1, m + 1, r, a, b);
    }
    ll t1 = fmxr(2 * v, l, m, a, m);
    ll t2 = fmxr(2 * v + 1, m + 1, r, m + 1, b);
    if (h[t1] > h[t2]) {
        return t1;
    }
    return t2;
}

ll fs(ll v, ll l, ll r, ll a, ll b) {
    s[v] = max(s[v], d[v] * (r - l + 1) - sum[v]);
    if (l == a && r == b) {
        return max(s[v], d[v] * (r - l + 1) - sum[v]);
    }
    ll m = (l + r) / 2;
    d[2 * v] = max(d[2 * v], d[v]);
    d[2 * v + 1] = max(d[2 * v + 1], d[v]);
    if (m >= b) {
        return fs(2 * v, l, m, a, b);
    }
    if (m < a) {
        return fs(2 * v + 1, m + 1, r, a, b);
    }
    ll t1 = fs(2 * v, l, m, a, m);
    ll t2 = fs(2 * v + 1, m + 1, r, m + 1, b);
    return t1 + t2;
}

signed main() {
    cin >> n;
    for (i = 0; i < n; i++) {
        cin >> h[i];
        cr[i] = n;
        cl[i] = -1;
        st.insert({i, i});
    }
    for (i = 0; i < n; i++) {
        while (!v.empty() && h[v.back()] < h[i]) {
            cr[v.back()] = i;
            v.pop_back();
        }
        v.push_back(i);
    }
    v.clear();
    for (i = n - 1; i >= 0; i--) {
        while (!v.empty() && h[v.back()] < h[i]) {
            cl[v.back()] = i;
            v.pop_back();
        }
        v.push_back(i);
    }
    build(1, 0, n - 1);
    for (t = 0; t < n - 1; t++) {
        cin >> k;
        auto it = st.find_by_order(k - 1);
        l1 = (*it).first;
        r1 = (*it).second;
        it++;
        l2 = (*it).first;
        r2 = (*it).second;
        mx1 = fmxr(1, 0, n - 1, l1, r1);
        mx2 = fmxl(1, 0, n - 1, l2, r2);
        if (h[mx1] > h[mx2]) {
            if (cl[mx2] + 1 <= mx2 - 1) {
                upd(1, 0, n - 1, cl[mx2] + 1, mx2 - 1, h[mx2]);
            }
        } else {
            if (mx1 + 1 <= cr[mx1] - 1) {
                upd(1, 0, n - 1, mx1 + 1, cr[mx1] - 1, h[mx1]);
            }
        }
        cout << fs(1, 0, n - 1, l1, r2) << endl;
        st.erase({l1, r1});
        st.erase({l2, r2});
        st.insert({l1, r2});
    }
    return 0;
}
